
# (C) 2001-2012 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Altera 
# Program License Subscription Agreement, Altera MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by Altera 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ----------------------------------------
# ncsim - auto-generated simulation script

# ----------------------------------------
# initialize variables
TOP_LEVEL_NAME="ddriii"
QSYS_SIMDIR="./../"
SKIP_FILE_COPY=0
SKIP_DEV_COM=0
SKIP_COM=0
SKIP_ELAB=0
SKIP_SIM=0
USER_DEFINED_ELAB_OPTIONS=""
USER_DEFINED_SIM_OPTIONS="-input \"@run 100; exit\""

# ----------------------------------------
# overwrite variables - DO NOT MODIFY!
# This block evaluates each command line argument, typically used for 
# overwriting variables. An example usage:
#   sh <simulator>_setup.sh SKIP_ELAB=1 SKIP_SIM=1
for expression in "$@"; do
  eval $expression
  if [ $? -ne 0 ]; then
    echo "Error: This command line argument, \"$expression\", is/has an invalid expression." >&2
    exit $?
  fi
done

# ----------------------------------------
# create compilation libraries
mkdir -p ./libraries/work/
mkdir -p ./libraries/ddriii_a0/
mkdir -p ./libraries/ddriii_ng0/
mkdir -p ./libraries/ddriii_dll0/
mkdir -p ./libraries/ddriii_oct0/
mkdir -p ./libraries/ddriii_c0/
mkdir -p ./libraries/ddriii_s0/
mkdir -p ./libraries/ddriii_m0/
mkdir -p ./libraries/ddriii_p0/
mkdir -p ./libraries/ddriii_pll0/
mkdir -p ./libraries/ddriii_ddriii/
mkdir -p ./libraries/altera_ver/
mkdir -p ./libraries/lpm_ver/
mkdir -p ./libraries/sgate_ver/
mkdir -p ./libraries/altera_mf_ver/
mkdir -p ./libraries/altera_lnsim_ver/
mkdir -p ./libraries/stratixiv_hssi_ver/
mkdir -p ./libraries/stratixiv_pcie_hip_ver/
mkdir -p ./libraries/stratixiv_ver/

# ----------------------------------------
# copy RAM/ROM files to simulation directory
if [ $SKIP_FILE_COPY -eq 0 ]; then
  cp -f $QSYS_SIMDIR/ddriii/ddriii_s0_sequencer_mem.hex ./
  cp -f $QSYS_SIMDIR/ddriii/ddriii_s0_AC_ROM.hex ./
  cp -f $QSYS_SIMDIR/ddriii/ddriii_s0_inst_ROM.hex ./
fi

# ----------------------------------------
# compile device library files
if [ $SKIP_DEV_COM -eq 0 ]; then
  ncvlog     "C:/altera/11.1/quartus/eda/sim_lib/altera_primitives.v"        -work altera_ver            
  ncvlog     "C:/altera/11.1/quartus/eda/sim_lib/220model.v"                 -work lpm_ver               
  ncvlog     "C:/altera/11.1/quartus/eda/sim_lib/sgate.v"                    -work sgate_ver             
  ncvlog     "C:/altera/11.1/quartus/eda/sim_lib/altera_mf.v"                -work altera_mf_ver         
  ncvlog -sv "C:/altera/11.1/quartus/eda/sim_lib/altera_lnsim.sv"            -work altera_lnsim_ver      
  ncvlog     "C:/altera/11.1/quartus/eda/sim_lib/stratixiv_hssi_atoms.v"     -work stratixiv_hssi_ver    
  ncvlog     "C:/altera/11.1/quartus/eda/sim_lib/stratixiv_pcie_hip_atoms.v" -work stratixiv_pcie_hip_ver
  ncvlog     "C:/altera/11.1/quartus/eda/sim_lib/stratixiv_atoms.v"          -work stratixiv_ver         
fi

# ----------------------------------------
# compile design files in correct order
if [ $SKIP_COM -eq 0 ]; then
  ncvlog                                  "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_mm_st_converter.v"                                        -work ddriii_a0     -cdslib ./cds_libs/ddriii_a0.cds.lib    
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_addr_cmd.v"                                               -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_addr_cmd_wrap.v"                                          -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ddr2_odt_gen.v"                                           -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ddr3_odt_gen.v"                                           -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_lpddr2_addr_cmd.v"                                        -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_odt_gen.v"                                                -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_rdwr_data_tmg.v"                                          -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_arbiter.v"                                                -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_burst_gen.v"                                              -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_cmd_gen.v"                                                -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_csr.v"                                                    -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_buffer.v"                                                 -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_buffer_manager.v"                                         -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_burst_tracking.v"                                         -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_dataid_manager.v"                                         -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_fifo.v"                                                   -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_list.v"                                                   -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_rdata_path.v"                                             -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_wdata_path.v"                                             -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_decoder.v"                                            -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_decoder_32_syn.v"                                     -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_decoder_64_syn.v"                                     -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_encoder.v"                                            -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_encoder_32_syn.v"                                     -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_encoder_64_syn.v"                                     -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_encoder_decoder_wrapper.v"                            -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_axi_st_converter.v"                                       -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_input_if.v"                                               -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_rank_timer.v"                                             -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_sideband.v"                                               -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_tbp.v"                                                    -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_timing_param.v"                                           -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_controller.v"                                             -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog     -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_controller_st_top.v"                                      -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog -sv -incdir $QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_if_nextgen_ddr3_controller_core.sv"                            -work ddriii_ng0    -cdslib ./cds_libs/ddriii_ng0.cds.lib   
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altera_mem_if_dll_stratixiv.sv"                                        -work ddriii_dll0   -cdslib ./cds_libs/ddriii_dll0.cds.lib  
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altera_mem_if_oct_stratixiv.sv"                                        -work ddriii_oct0   -cdslib ./cds_libs/ddriii_oct0.cds.lib  
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_c0.v"                                                           -work ddriii_c0     -cdslib ./cds_libs/ddriii_c0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_s0.v"                                                           -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/altera_avalon_sc_fifo.v"                                               -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/altera_mem_if_sequencer_cpu_no_ifdef_params_sim_cpu_inst.v"            -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/altera_mem_if_sequencer_cpu_no_ifdef_params_sim_cpu_inst_test_bench.v" -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altera_mem_if_sequencer_mem_no_ifdef_params.sv"                        -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_arbitrator.sv"                                           -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_burst_uncompressor.sv"                                   -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_master_agent.sv"                                         -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_master_translator.sv"                                    -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_slave_agent.sv"                                          -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_slave_translator.sv"                                     -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/altera_reset_controller.v"                                             -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/altera_reset_synchronizer.v"                                           -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_addr_router.sv"                                              -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_addr_router_001.sv"                                          -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_cmd_xbar_demux.sv"                                           -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_cmd_xbar_demux_001.sv"                                       -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_cmd_xbar_mux_003.sv"                                         -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_id_router.sv"                                                -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_id_router_003.sv"                                            -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_irq_mapper.sv"                                               -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_rsp_xbar_demux_003.sv"                                       -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_rsp_xbar_mux.sv"                                             -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ac_ROM_no_ifdef_params.v"                                   -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ac_ROM_reg.v"                                               -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_bitcheck.v"                                                 -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/rw_manager_core.sv"                                                    -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_datamux.v"                                                  -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_data_broadcast.v"                                           -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_data_decoder.v"                                             -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ddr3.v"                                                     -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_di_buffer.v"                                                -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_di_buffer_wrap.v"                                           -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_dm_decoder.v"                                               -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/rw_manager_generic.sv"                                                 -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_inst_ROM_no_ifdef_params.v"                                 -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_inst_ROM_reg.v"                                             -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_jumplogic.v"                                                -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_lfsr12.v"                                                   -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_lfsr36.v"                                                   -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_lfsr72.v"                                                   -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_pattern_fifo.v"                                             -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ram.v"                                                      -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ram_csr.v"                                                  -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_read_datapath.v"                                            -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_write_decoder.v"                                            -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_data_mgr.sv"                                                 -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_phy_mgr.sv"                                                  -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_reg_file.sv"                                                 -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/sequencer_scc_acv_phase_decode.v"                                      -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_scc_acv_wrapper.sv"                                          -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_scc_mgr.sv"                                                  -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/sequencer_scc_reg_file.v"                                              -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/sequencer_scc_siii_phase_decode.v"                                     -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_scc_siii_wrapper.sv"                                         -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/sequencer_scc_sv_phase_decode.v"                                       -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_scc_sv_wrapper.sv"                                           -work ddriii_s0     -cdslib ./cds_libs/ddriii_s0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/afi_mux_ddr3_ddrx.v"                                                   -work ddriii_m0     -cdslib ./cds_libs/ddriii_m0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_clock_pair_generator.v"                                      -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_read_valid_selector.v"                                       -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_addr_cmd_datapath.v"                                         -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_reset.v"                                                     -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_acv_ldc.v"                                                   -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_addr_cmd_pads.v"                                             -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_addr_cmd_ldc_pads.v"                                         -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_addr_cmd_ldc_pad.v"                                          -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/addr_cmd_non_ldc_pad.v"                                                -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_memphy.v"                                                    -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_reset_sync.v"                                                -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_new_io_pads.v"                                               -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_fr_cycle_shifter.v"                                          -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_read_datapath.v"                                             -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_write_datapath.v"                                            -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_hr_to_fr.v"                                                  -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_simple_ddio_out.v"                                           -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_p0_sequencer_mux_bridge.sv"                                     -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_p0_phy_csr.sv"                                                  -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_iss_probe.v"                                                 -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_flop_mem.v"                                                  -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_p0.sv"                                                          -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_altdqdqs.v"                                                  -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altdq_dqs2_ddio_3reg_stratixiv.sv"                                     -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altdq_dqs2_abstract.sv"                                                -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/altdq_dqs2_cal_delays.sv"                                              -work ddriii_p0     -cdslib ./cds_libs/ddriii_p0.cds.lib    
  ncvlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_pll0.sv"                                                        -work ddriii_pll0   -cdslib ./cds_libs/ddriii_pll0.cds.lib  
  ncvlog                                  "$QSYS_SIMDIR/ddriii/ddriii_0002.v"                                                         -work ddriii_ddriii -cdslib ./cds_libs/ddriii_ddriii.cds.lib
  ncvlog                                  "$QSYS_SIMDIR/ddriii.v"                                                                                                                                 
fi

# ----------------------------------------
# elaborate top level design
if [ $SKIP_ELAB -eq 0 ]; then
  ncelab -access +w+r+c -namemap_mixgen -timescale 1ps/1ps $USER_DEFINED_ELAB_OPTIONS $TOP_LEVEL_NAME
fi

# ----------------------------------------
# simulate
if [ $SKIP_SIM -eq 0 ]; then
  eval ncsim $USER_DEFINED_SIM_OPTIONS $TOP_LEVEL_NAME
fi
