
# (C) 2001-2012 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Altera 
# Program License Subscription Agreement, Altera MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by Altera 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ----------------------------------------
# Auto-generated simulation script

# ----------------------------------------
# Initialize the variable
if ![info exists SYSTEM_INSTANCE_NAME] { 
  set SYSTEM_INSTANCE_NAME ""
} elseif { ![ string match "" $SYSTEM_INSTANCE_NAME ] } { 
  set SYSTEM_INSTANCE_NAME "/$SYSTEM_INSTANCE_NAME"
} 

if ![info exists TOP_LEVEL_NAME] { 
  set TOP_LEVEL_NAME "ddriii"
} elseif { ![ string match "" $TOP_LEVEL_NAME ] } { 
  set TOP_LEVEL_NAME "$TOP_LEVEL_NAME"
} 

if ![info exists QSYS_SIMDIR] { 
  set QSYS_SIMDIR "./../"
} elseif { ![ string match "" $QSYS_SIMDIR ] } { 
  set QSYS_SIMDIR "$QSYS_SIMDIR"
} 


# ----------------------------------------
# Copy ROM/RAM files to simulation directory
file copy -force $QSYS_SIMDIR/ddriii/ddriii_s0_sequencer_mem.hex ./
file copy -force $QSYS_SIMDIR/ddriii/ddriii_s0_AC_ROM.hex ./
file copy -force $QSYS_SIMDIR/ddriii/ddriii_s0_inst_ROM.hex ./

# ----------------------------------------
# Create compilation libraries
proc ensure_lib { lib } { if ![file isdirectory $lib] { vlib $lib } }
ensure_lib      ./libraries/     
ensure_lib      ./libraries/work/
vmap       work ./libraries/work/
if { ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] } {
  ensure_lib                        ./libraries/altera_ver/            
  vmap       altera_ver             ./libraries/altera_ver/            
  ensure_lib                        ./libraries/lpm_ver/               
  vmap       lpm_ver                ./libraries/lpm_ver/               
  ensure_lib                        ./libraries/sgate_ver/             
  vmap       sgate_ver              ./libraries/sgate_ver/             
  ensure_lib                        ./libraries/altera_mf_ver/         
  vmap       altera_mf_ver          ./libraries/altera_mf_ver/         
  ensure_lib                        ./libraries/altera_lnsim_ver/      
  vmap       altera_lnsim_ver       ./libraries/altera_lnsim_ver/      
  ensure_lib                        ./libraries/stratixiv_hssi_ver/    
  vmap       stratixiv_hssi_ver     ./libraries/stratixiv_hssi_ver/    
  ensure_lib                        ./libraries/stratixiv_pcie_hip_ver/
  vmap       stratixiv_pcie_hip_ver ./libraries/stratixiv_pcie_hip_ver/
  ensure_lib                        ./libraries/stratixiv_ver/         
  vmap       stratixiv_ver          ./libraries/stratixiv_ver/         
}
ensure_lib               ./libraries/ddriii_a0/    
vmap       ddriii_a0     ./libraries/ddriii_a0/    
ensure_lib               ./libraries/ddriii_ng0/   
vmap       ddriii_ng0    ./libraries/ddriii_ng0/   
ensure_lib               ./libraries/ddriii_dll0/  
vmap       ddriii_dll0   ./libraries/ddriii_dll0/  
ensure_lib               ./libraries/ddriii_oct0/  
vmap       ddriii_oct0   ./libraries/ddriii_oct0/  
ensure_lib               ./libraries/ddriii_c0/    
vmap       ddriii_c0     ./libraries/ddriii_c0/    
ensure_lib               ./libraries/ddriii_s0/    
vmap       ddriii_s0     ./libraries/ddriii_s0/    
ensure_lib               ./libraries/ddriii_m0/    
vmap       ddriii_m0     ./libraries/ddriii_m0/    
ensure_lib               ./libraries/ddriii_p0/    
vmap       ddriii_p0     ./libraries/ddriii_p0/    
ensure_lib               ./libraries/ddriii_pll0/  
vmap       ddriii_pll0   ./libraries/ddriii_pll0/  
ensure_lib               ./libraries/ddriii_ddriii/
vmap       ddriii_ddriii ./libraries/ddriii_ddriii/

# ----------------------------------------
# Compile device library files
alias dev_com {
  echo "\[exec\] dev_com"
  if { ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] } {
    vlog     "C:/altera/11.1/quartus/eda/sim_lib/altera_primitives.v"        -work altera_ver            
    vlog     "C:/altera/11.1/quartus/eda/sim_lib/220model.v"                 -work lpm_ver               
    vlog     "C:/altera/11.1/quartus/eda/sim_lib/sgate.v"                    -work sgate_ver             
    vlog     "C:/altera/11.1/quartus/eda/sim_lib/altera_mf.v"                -work altera_mf_ver         
    vlog -sv "C:/altera/11.1/quartus/eda/sim_lib/altera_lnsim.sv"            -work altera_lnsim_ver      
    vlog     "C:/altera/11.1/quartus/eda/sim_lib/stratixiv_hssi_atoms.v"     -work stratixiv_hssi_ver    
    vlog     "C:/altera/11.1/quartus/eda/sim_lib/stratixiv_pcie_hip_atoms.v" -work stratixiv_pcie_hip_ver
    vlog     "C:/altera/11.1/quartus/eda/sim_lib/stratixiv_atoms.v"          -work stratixiv_ver         
  }
}

# ----------------------------------------
# Compile the design files in correct order
alias com {
  echo "\[exec\] com"
  vlog                                  "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_mm_st_converter.v"                                        -work ddriii_a0    
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_addr_cmd.v"                                               -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_addr_cmd_wrap.v"                                          -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ddr2_odt_gen.v"                                           -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ddr3_odt_gen.v"                                           -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_lpddr2_addr_cmd.v"                                        -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_odt_gen.v"                                                -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_rdwr_data_tmg.v"                                          -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_arbiter.v"                                                -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_burst_gen.v"                                              -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_cmd_gen.v"                                                -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_csr.v"                                                    -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_buffer.v"                                                 -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_buffer_manager.v"                                         -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_burst_tracking.v"                                         -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_dataid_manager.v"                                         -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_fifo.v"                                                   -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_list.v"                                                   -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_rdata_path.v"                                             -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_wdata_path.v"                                             -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_decoder.v"                                            -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_decoder_32_syn.v"                                     -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_decoder_64_syn.v"                                     -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_encoder.v"                                            -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_encoder_32_syn.v"                                     -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_encoder_64_syn.v"                                     -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_ecc_encoder_decoder_wrapper.v"                            -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_axi_st_converter.v"                                       -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_input_if.v"                                               -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_rank_timer.v"                                             -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_sideband.v"                                               -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_tbp.v"                                                    -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_timing_param.v"                                           -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_controller.v"                                             -work ddriii_ng0   
  vlog     +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_ddrx_controller_st_top.v"                                      -work ddriii_ng0   
  vlog -sv +incdir+$QSYS_SIMDIR/ddriii/ "$QSYS_SIMDIR/ddriii/alt_mem_if_nextgen_ddr3_controller_core.sv"                            -work ddriii_ng0   
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altera_mem_if_dll_stratixiv.sv"                                        -work ddriii_dll0  
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altera_mem_if_oct_stratixiv.sv"                                        -work ddriii_oct0  
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_c0.v"                                                           -work ddriii_c0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_s0.v"                                                           -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/altera_avalon_sc_fifo.v"                                               -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/altera_mem_if_sequencer_cpu_no_ifdef_params_sim_cpu_inst.v"            -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/altera_mem_if_sequencer_cpu_no_ifdef_params_sim_cpu_inst_test_bench.v" -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altera_mem_if_sequencer_mem_no_ifdef_params.sv"                        -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_arbitrator.sv"                                           -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_burst_uncompressor.sv"                                   -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_master_agent.sv"                                         -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_master_translator.sv"                                    -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_slave_agent.sv"                                          -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altera_merlin_slave_translator.sv"                                     -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/altera_reset_controller.v"                                             -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/altera_reset_synchronizer.v"                                           -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_addr_router.sv"                                              -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_addr_router_001.sv"                                          -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_cmd_xbar_demux.sv"                                           -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_cmd_xbar_demux_001.sv"                                       -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_cmd_xbar_mux_003.sv"                                         -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_id_router.sv"                                                -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_id_router_003.sv"                                            -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_irq_mapper.sv"                                               -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_rsp_xbar_demux_003.sv"                                       -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_s0_rsp_xbar_mux.sv"                                             -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ac_ROM_no_ifdef_params.v"                                   -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ac_ROM_reg.v"                                               -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_bitcheck.v"                                                 -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/rw_manager_core.sv"                                                    -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_datamux.v"                                                  -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_data_broadcast.v"                                           -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_data_decoder.v"                                             -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ddr3.v"                                                     -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_di_buffer.v"                                                -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_di_buffer_wrap.v"                                           -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_dm_decoder.v"                                               -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/rw_manager_generic.sv"                                                 -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_inst_ROM_no_ifdef_params.v"                                 -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_inst_ROM_reg.v"                                             -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_jumplogic.v"                                                -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_lfsr12.v"                                                   -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_lfsr36.v"                                                   -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_lfsr72.v"                                                   -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_pattern_fifo.v"                                             -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ram.v"                                                      -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_ram_csr.v"                                                  -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_read_datapath.v"                                            -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/rw_manager_write_decoder.v"                                            -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_data_mgr.sv"                                                 -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_phy_mgr.sv"                                                  -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_reg_file.sv"                                                 -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/sequencer_scc_acv_phase_decode.v"                                      -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_scc_acv_wrapper.sv"                                          -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_scc_mgr.sv"                                                  -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/sequencer_scc_reg_file.v"                                              -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/sequencer_scc_siii_phase_decode.v"                                     -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_scc_siii_wrapper.sv"                                         -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/sequencer_scc_sv_phase_decode.v"                                       -work ddriii_s0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/sequencer_scc_sv_wrapper.sv"                                           -work ddriii_s0    
  vlog                                  "$QSYS_SIMDIR/ddriii/afi_mux_ddr3_ddrx.v"                                                   -work ddriii_m0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_clock_pair_generator.v"                                      -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_read_valid_selector.v"                                       -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_addr_cmd_datapath.v"                                         -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_reset.v"                                                     -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_acv_ldc.v"                                                   -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_addr_cmd_pads.v"                                             -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_addr_cmd_ldc_pads.v"                                         -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_addr_cmd_ldc_pad.v"                                          -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/addr_cmd_non_ldc_pad.v"                                                -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_memphy.v"                                                    -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_reset_sync.v"                                                -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_new_io_pads.v"                                               -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_fr_cycle_shifter.v"                                          -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_read_datapath.v"                                             -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_write_datapath.v"                                            -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_hr_to_fr.v"                                                  -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_simple_ddio_out.v"                                           -work ddriii_p0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_p0_sequencer_mux_bridge.sv"                                     -work ddriii_p0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_p0_phy_csr.sv"                                                  -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_iss_probe.v"                                                 -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_flop_mem.v"                                                  -work ddriii_p0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_p0.sv"                                                          -work ddriii_p0    
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_p0_altdqdqs.v"                                                  -work ddriii_p0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altdq_dqs2_ddio_3reg_stratixiv.sv"                                     -work ddriii_p0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altdq_dqs2_abstract.sv"                                                -work ddriii_p0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/altdq_dqs2_cal_delays.sv"                                              -work ddriii_p0    
  vlog -sv                              "$QSYS_SIMDIR/ddriii/ddriii_pll0.sv"                                                        -work ddriii_pll0  
  vlog                                  "$QSYS_SIMDIR/ddriii/ddriii_0002.v"                                                         -work ddriii_ddriii
  vlog                                  "$QSYS_SIMDIR/ddriii.v"                                                                                        
}

# ----------------------------------------
# Elaborate top level design
alias elab {
  echo "\[exec\] elab"
  vsim -t ps -L work -L ddriii_a0 -L ddriii_ng0 -L ddriii_dll0 -L ddriii_oct0 -L ddriii_c0 -L ddriii_s0 -L ddriii_m0 -L ddriii_p0 -L ddriii_pll0 -L ddriii_ddriii -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L stratixiv_hssi_ver -L stratixiv_pcie_hip_ver -L stratixiv_ver $TOP_LEVEL_NAME
}

# ----------------------------------------
# Elaborate the top level design with novopt option
alias elab_debug {
  echo "\[exec\] elab_debug"
  vsim -novopt -t ps -L work -L ddriii_a0 -L ddriii_ng0 -L ddriii_dll0 -L ddriii_oct0 -L ddriii_c0 -L ddriii_s0 -L ddriii_m0 -L ddriii_p0 -L ddriii_pll0 -L ddriii_ddriii -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L stratixiv_hssi_ver -L stratixiv_pcie_hip_ver -L stratixiv_ver $TOP_LEVEL_NAME
}

# ----------------------------------------
# Compile all the design files and elaborate the top level design
alias ld "
  dev_com
  com
  elab
"

# ----------------------------------------
# Compile all the design files and elaborate the top level design with -novopt
alias ld_debug "
  dev_com
  com
  elab_debug
"

# ----------------------------------------
# Print out user commmand line aliases
alias h {
  echo "List Of Command Line Aliases"
  echo
  echo "dev_com                       -- Compile device library files"
  echo
  echo "com                           -- Compile the design files in correct order"
  echo
  echo "elab                          -- Elaborate top level design"
  echo
  echo "elab_debug                    -- Elaborate the top level design with novopt option"
  echo
  echo "ld                            -- Compile all the design files and elaborate the top level design"
  echo
  echo "ld_debug                      -- Compile all the design files and elaborate the top level design with -novopt"
  echo
  echo 
  echo
  echo "List Of Variables"
  echo
  echo "TOP_LEVEL_NAME                -- Top level module name."
  echo
  echo "SYSTEM_INSTANCE_NAME          -- Instantiated system module name inside top level module."
  echo
  echo "QSYS_SIMDIR                   -- Qsys base simulation directory."
}
h
